/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.binarysearchtree;

/**
 *
 * @author omozegieaziegbe
 */
public class BinarySearchTree {

    public static TreeNode findParent(TreeNode root, TreeNode node) {
        if (root == null || root == node) {
            return null; // No parent or node is root
        }

        TreeNode parent = null;
        TreeNode current = root;

        while (current != null) {
            if (node.key < current.key) {
                parent = current;
                current = current.left;
            } else if (node.key > current.key) {
                parent = current;
                current = current.right;
            } else {
                // Node found, return its parent
                return parent;
            }
        }

        return null; // Node not found in the tree
    }

    public static void main(String[] args) {

        // Constructing a sample BST
        TreeNode root = new TreeNode(10);
        root.left = new TreeNode(5);
        root.right = new TreeNode(15);
        root.left.left = new TreeNode(3);
        root.left.right = new TreeNode(7);
        root.right.left = new TreeNode(13);
        root.right.right = new TreeNode(18);

        // Suppose we want to find the parent of node with key 7
        TreeNode nodeToFind = root.right.right;
        TreeNode parent = findParent(root, nodeToFind);

        if (parent != null) {
            System.out.println("Parent of node " + nodeToFind.key + " is " + parent.key);
        } else {
            System.out.println("Node " + nodeToFind.key + " is either root or not found in the tree.");
        }

    }
}
